package com.gmail.sg06.greenrevolution.weightedplayer;

import java.util.ArrayList;

import jp.ac.kyoto_u.sugaryAgent.SugaryBodyguard;
import jp.ac.kyoto_u.sugaryAgent.SugaryMedium;
import jp.ac.kyoto_u.sugaryAgent.SugaryPossessed;
import jp.ac.kyoto_u.sugaryAgent.SugarySeer;
import jp.ac.kyoto_u.sugaryAgent.SugaryVillager;
import jp.ac.kyoto_u.sugaryAgent.SugaryWerewolf;
import jp.ac.osakafu_u.cs.ss.hasegawa.player.WeightedPlayer;
import jp.ac.shibaura_it.ma15082.WasabiPlayer;
import jp.ac.tohoku.ecei.shino.takaaki_okawa.agent.KatakanaBodyguard;
import jp.ac.tohoku.ecei.shino.takaaki_okawa.agent.KatakanaMedium;
import jp.ac.tohoku.ecei.shino.takaaki_okawa.agent.KatakanaPossessed;
import jp.ac.tohoku.ecei.shino.takaaki_okawa.agent.KatakanaSeer;
import jp.ac.tohoku.ecei.shino.takaaki_okawa.agent.KatakanaVillager;
import jp.ac.tohoku.ecei.shino.takaaki_okawa.agent.KatakanaWerewolf;
import jp.halfmoon.inaba.aiwolf.strategyplayer.StrategyBodyGuard;
import jp.halfmoon.inaba.aiwolf.strategyplayer.StrategyMedium;
import jp.halfmoon.inaba.aiwolf.strategyplayer.StrategyPossessed;
import jp.halfmoon.inaba.aiwolf.strategyplayer.StrategySeer;
import jp.halfmoon.inaba.aiwolf.strategyplayer.StrategyVillager;
import jp.halfmoon.inaba.aiwolf.strategyplayer.StrategyWerewolf;

import org.aiwolf.client.base.player.AbstractRole;
import org.aiwolf.client.base.player.AbstractRoleAssignPlayer;

import com.carlo.aiwolf.bayes.player.BayesBodyguard;
import com.carlo.aiwolf.bayes.player.BayesMedium;
import com.carlo.aiwolf.bayes.player.BayesSeer;
import com.carlo.aiwolf.bayes.player.BayesVillager;
import com.carlo.aiwolf.bayes.player.CarloWerewolf;
import com.koizu.aiwolf.player.Possessed;

public class HaseRoleAssignPlayer extends AbstractRoleAssignPlayer {

	public static int playerNum_ = 5;

	@Override
	public String getName() {
		return "Litt1eGirl";
	}

	public HaseRoleAssignPlayer() {
		setVillagerPlayer(getVillager());
		setSeerPlayer(getSeer());
		setMediumPlayer(getMedium());
		setBodyguardPlayer(getBodyguard());
		setPossessedPlayer(getPossessed());
		setWerewolfPlayer(getWerewolf());
	}

	private AbstractRole getVillager() {
		ArrayList<AbstractRole> list = new ArrayList<AbstractRole>();
		// 2位:ksugar
		AbstractRole kSugarVillager = new SugaryVillager();
		list.add(kSugarVillager);
		// 3位:udon
		AbstractRole udonVillager = new StrategyVillager();
		list.add(udonVillager);
		// 4位:wasabi
		AbstractRole wasabiVillager = new WasabiPlayer();
		list.add(wasabiVillager);
		// 6位:carlo
		AbstractRole carloVillager = new BayesVillager();
		list.add(carloVillager);
		// 9位:howls
		AbstractRole howlsVillager = new KatakanaVillager();
		list.add(howlsVillager);

		// 2015 2位:hataraki
		AbstractRole hatarakiVillager = new com.gmail.jinro.noppo.players.Villager();
		list.add(hatarakiVillager);

		// 2015 3位:satsuki
		AbstractRole satsukiVillager = new org.aiwolf.Satsuki.LearningPlayer.KajiVillagerPlayer();
		list.add(satsukiVillager);

		WeightedPlayer player = new WeightedPlayer(list, true);
		return player;
	}

	private AbstractRole getSeer() {
		ArrayList<AbstractRole> list = new ArrayList<AbstractRole>();
		// 2位:ksugar
		AbstractRole kSugarSeer = new SugarySeer();
		list.add(kSugarSeer);
		// 3位:udon
		AbstractRole udonSeer = new StrategySeer();
		list.add(udonSeer);
		// 4位:wasabi
		AbstractRole wasabiSeer = new WasabiPlayer();
		list.add(wasabiSeer);
		// carlo
		AbstractRole carloSeer = new BayesSeer();
		list.add(carloSeer);
		// howls
		AbstractRole howlsSeer = new KatakanaSeer();
		list.add(howlsSeer);

		// 2015 2位:hataraki
		AbstractRole hatarakiSeer = new com.gmail.jinro.noppo.players.Seer();
		list.add(hatarakiSeer);

		// 2015 3位:satsuki
		AbstractRole satsukiSeer = new org.aiwolf.Satsuki.LearningPlayer.KajiSeerPlayer();
		list.add(satsukiSeer);

		WeightedPlayer player = new WeightedPlayer(list,true);

		return player;
	}

	private AbstractRole getMedium() {
		ArrayList<AbstractRole> list = new ArrayList<AbstractRole>();
		// 2位:ksugar
		AbstractRole kSugarMedium = new SugaryMedium();
		list.add(kSugarMedium);
		// 3位:udon
		AbstractRole udonMedium = new StrategyMedium();
		list.add(udonMedium);
		// 4位:wasabi
		AbstractRole wasabiMedium = new WasabiPlayer();
		list.add(wasabiMedium);
		// carlo
		AbstractRole carloMedium = new BayesMedium();
		list.add(carloMedium);
		// howls
		AbstractRole howlsMedium = new KatakanaMedium();
		list.add(howlsMedium);

		// 2015 2位:hataraki
		AbstractRole hatarakiMedium = new com.gmail.jinro.noppo.players.Medium();
		list.add(hatarakiMedium);

		// 2015 3位:satsuki
		AbstractRole satsukiMedium = new org.aiwolf.Satsuki.LearningPlayer.KajiMediumPlayer();
		list.add(satsukiMedium);

		WeightedPlayer player = new WeightedPlayer(list,true);
		return player;
	}

	private AbstractRole getBodyguard() {
		ArrayList<AbstractRole> list = new ArrayList<AbstractRole>();
		// 2位:ksugar
		AbstractRole kSugarBodyguard = new SugaryBodyguard();
		list.add(kSugarBodyguard);
		// 3位:udon
		AbstractRole udonBodyguard = new StrategyBodyGuard();
		list.add(udonBodyguard);
		// 4位:wasabi
		AbstractRole wasabiBodyguard = new WasabiPlayer();
		list.add(wasabiBodyguard);
		// carlo
		AbstractRole carloBodyguard = new BayesBodyguard();
		list.add(carloBodyguard);
		// howls
		AbstractRole howlsBodyguard = new KatakanaBodyguard();
		list.add(howlsBodyguard);

		// 2015 2位:hataraki
		AbstractRole hatarakiBodyguard = new com.gmail.jinro.noppo.players.Bodyguard();
		list.add(hatarakiBodyguard);

		// 2015 3位:satsuki
		AbstractRole satsukiBodyguard = new org.aiwolf.Satsuki.LearningPlayer.KajiBodyGuradPlayer();
		list.add(satsukiBodyguard);

		WeightedPlayer player = new WeightedPlayer(list,true);
		return player;
	}

	private AbstractRole getPossessed() {
		ArrayList<AbstractRole> list = new ArrayList<AbstractRole>();
		// 2位:ksugar
		AbstractRole kSugarPossessed = new SugaryPossessed();
		list.add(kSugarPossessed);
		// 3位:udon
		AbstractRole udonPossessed = new StrategyPossessed();
		list.add(udonPossessed);
		// 4位:wasabi
		AbstractRole wasabiPossessed = new WasabiPlayer();
		list.add(wasabiPossessed);
		// carlo
		AbstractRole carloPossessed = new Possessed();
		list.add(carloPossessed);
		// howls
		AbstractRole howlsPossessed = new KatakanaPossessed();
		list.add(howlsPossessed);

		// 2015 2位:hataraki
		AbstractRole hatarakiPossessed = new com.gmail.jinro.noppo.players.Possessed();
		list.add(hatarakiPossessed);

		// 2015 3位:satsuki
		AbstractRole satsukiSeer = new org.aiwolf.Satsuki.LearningPlayer.KajiPossessedPlayer();
		list.add(satsukiSeer);

		WeightedPlayer player = new WeightedPlayer(list,true);
		return player;
	}

	private AbstractRole getWerewolf() {
		ArrayList<AbstractRole> list = new ArrayList<AbstractRole>();
		// 2位:ksugar
		AbstractRole kSugarWerewolf = new SugaryWerewolf();
		list.add(kSugarWerewolf);
		// 3位:udon
		AbstractRole udonWerewolf = new StrategyWerewolf();
		list.add(udonWerewolf);
		// 4位:wasabi
		AbstractRole wasabiWerewolf = new WasabiPlayer();
		list.add(wasabiWerewolf);
		// carlo
		AbstractRole carloWerewolf = new CarloWerewolf();
		list.add(carloWerewolf);
		// howls
		AbstractRole howlsWerewolf = new KatakanaWerewolf();
		list.add(howlsWerewolf);

		// 2015 2位:hataraki
		AbstractRole hatarakiWerewolf = new com.gmail.jinro.noppo.players.Wolf();
		list.add(hatarakiWerewolf);

		// 2015 3位:satsuki
		AbstractRole satsukiWerewolf = new org.aiwolf.Satsuki.LearningPlayer.KajiWereWolfPlayer();
		list.add(satsukiWerewolf);

		WeightedPlayer player = new WeightedPlayer(list,true);
		return player;
	}

}
