package com.gmail.sg06.greenrevolution.weightedplayer;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import org.aiwolf.client.lib.Topic;
import org.aiwolf.client.lib.Utterance;
import org.aiwolf.common.data.Role;

public class SayHello {

	private int cnt_;

	private String[] nums_ = { "3", "2", "8", "9", "14", "5", "7" };

	List<String> numList_;

	private String[] roles_ = { "v", "v", "w", "v", "m", "w", "v" };

	List<String> roleList_;

	boolean isJun_;

	Role junRole_;

	public SayHello() {
		cnt_ = -1;
		numList_ = new ArrayList<String>();
		numList_.addAll(Arrays.asList(nums_));
		roleList_ = new ArrayList<String>();
		roleList_.addAll(Arrays.asList(roles_));
		isJun_ = true;
	}

	public String getWords() {
		cnt_++;
		if (cnt_ % 5 == 1) {
			return "vote" + ":7";
		} else if (cnt_ % 5 == 2) {
			return "skip";
		} else if (cnt_ != 9) {
			String num = numList_.get(0);
			String role = roleList_.get(0);
			numList_.remove(0);
			roleList_.remove(0);
			return "estimate:" + num + ":" + role;
		}
		return "you:1";
	}

	public void getCheckWords(Utterance uttr) {
		if (isJun_) {
			cnt_++;
			if (cnt_ % 5 == 1) {
				if (uttr.getTopic() == Topic.VOTE) {
					if (uttr.getTarget().getAgentIdx() != 7) {
						isJun_ = false;
					}
				} else {
					isJun_ = false;
				}
			} else if (cnt_ % 5 == 2) {
				if (uttr.getTopic() != Topic.SKIP) {
					isJun_ = false;
				}
			} else if (cnt_ != 9) {
				if (uttr.getTopic() == Topic.ESTIMATE) {
					String num = numList_.get(0);
					String role = roleList_.get(0);
					numList_.remove(0);
					roleList_.remove(0);
					if (uttr.getTarget().getAgentIdx() == Integer.valueOf(num)) {
						if (uttr.getRole() != transRole(role)) {
							isJun_ = false;
						}
					} else {
						isJun_ = false;
					}
				} else {
					isJun_ = false;
				}
			} else {
				if (uttr.getTopic() == Topic.ESTIMATE) {
					if (uttr.getTarget().getAgentIdx() == 1) {
						junRole_ = uttr.getRole();
					} else {
						isJun_ = false;
					}
				} else {
					isJun_ = false;
				}
			}
		}
	}

	private Role transRole(String roleName) {
		if (roleName.equals("v")) {
			return Role.VILLAGER;
		}
		if (roleName.equals("w")) {
			return Role.WEREWOLF;
		}
		if (roleName.equals("m")) {
			return Role.MEDIUM;
		}
		if (roleName.equals("b")) {
			return Role.BODYGUARD;
		}
		if (roleName.equals("s")) {
			return Role.SEER;
		}
		return Role.POSSESSED;
	}

	public boolean isJun() {
		return isJun_;
	}

	public void setJun(boolean isJun) {
		isJun_ = isJun;
	}

	public Role getJunRole() {
		return junRole_;
	}

	public void setJunRole(Role junRole) {
		junRole_ = junRole;
	}

}
