package com.gmail.sg06.greenrevolution.jingai_table;

import java.util.ArrayList;

import org.aiwolf.common.data.Role;

import com.gmail.sg06.greenrevolution.data.COData;

public class DefaultJingaiTable extends AbstractJingaiTable {

//	ArrayList<int[]> patterns_;		// 占いCO の中から人狼陣営の組合せを求めるために使う
//
//	int[] temp_;		// 組合せの一時保管場所


/**
 * コンストラクタ
 */
	public DefaultJingaiTable(){
		super();
	}





	@Override
	public void calcAttackInfo(int targetIdx) {
	// 襲撃先が人狼
		ArrayList<Integer> list = tableIndexList(targetIdx, Role.WEREWOLF);
		double rate = getRates()[8];
		for(Integer i: list){
			getRateTable()[i][0] *= rate;
		}
	}





	@Override
	public void calcVoteInfo(int agentIdx, int targetIdx) {
		ArrayList<Integer> list;
		double rate;

	// 狂人が人狼に投票
		list = tableIndexList(agentIdx, Role.POSSESSED, targetIdx, Role.WEREWOLF);//狂人が人狼に投票
		rate = getRates()[0];
		for(Integer i: list){
			getRateTable()[i][0] *= rate;
		}
	// 人狼が狂人に投票
		list = tableIndexList(agentIdx, Role.WEREWOLF, targetIdx, Role.POSSESSED);//人狼が狂人に投票
		rate = getRates()[1];
		for(Integer i: list){
			getRateTable()[i][0] *= rate;
		}
	// 人狼が人狼に投票
		list = tableIndexList(agentIdx, Role.WEREWOLF, targetIdx, Role.WEREWOLF);//人狼が人狼に投票
		rate = getRates()[2];
		for(Integer i: list){
			getRateTable()[i][0] *= rate;
		}
	}


	@Override
	public void calcVoteInfo(int agentIdx, int targetIdx, int day){
		// 実装無
	}





	@Override
	public void calcDivineInfo(int agentIdx, int targetIdx, boolean isBlack) {
		ArrayList<Integer> list;
		double rate;

	// 白出しの場合
		if(!isBlack){
		// 村人陣営が人狼を白出し
			list = tableIndexList(agentIdx, Role.SEER, targetIdx, Role.WEREWOLF);//村人陣営が人狼を白出し
			rate = getRates()[6];
			for(Integer i: list){
				getRateTable()[i][1] *= rate;
			}
		}

	// 黒出しの場合
		else{
		// 村人陣営が村人陣営に黒出し
			list = tableIndexList(agentIdx, Role.SEER, targetIdx, Role.VILLAGER);//村人陣営が村人陣営を黒出し
			rate = getRates()[6];
			for(Integer i: list){
				getRateTable()[i][1] *= rate;
			}
		// 狂人が人狼に黒出し
			list = tableIndexList(agentIdx, Role.POSSESSED, targetIdx, Role.WEREWOLF);//狂人が人狼に黒出し
			rate = getRates()[3];
			for(Integer i: list){
				getRateTable()[i][1] *= rate;
			}
		// 人狼が狂人に黒出し
			list = tableIndexList(agentIdx, Role.WEREWOLF, targetIdx, Role.POSSESSED);//人狼が狂人に黒出し
			rate = getRates()[4];
			for(Integer i: list){
				getRateTable()[i][1] *= rate;
			}
		// 人狼が人狼に黒出し
			list = tableIndexList(agentIdx, Role.WEREWOLF, targetIdx, Role.WEREWOLF);//人狼が人狼に黒出し
			rate = getRates()[5];
			for(Integer i: list){
				getRateTable()[i][1] *= rate;
			}
		}
	}





	@Override
	public void calcInquestInfo(int agentIdx, int targetIdx, boolean isBlack) {
		ArrayList<Integer> list;
		double rate;

	// 白出しの場合
		if(!isBlack){
		// 村人陣営が人狼に白出し
			list = tableIndexList(agentIdx, Role.MEDIUM, targetIdx, Role.WEREWOLF);//村人陣営が人狼を白出し
			rate = getRates()[7];
			for(Integer i: list){
				getRateTable()[i][1] *= rate;
			}
		}

	// 黒出しの場合
		else{
		// 村人陣営が村人陣営に黒出し
			list = tableIndexList(agentIdx, Role.MEDIUM, targetIdx, Role.VILLAGER);//村人陣営が村人陣営を黒出し
			rate = getRates()[7];
			for(Integer i: list){
				getRateTable()[i][1] *= rate;
			}
		}
	}


	@Override
	public void calcSeerCOInfo(ArrayList<Integer> seerCOList) {
	// 人狼陣営からのみ占いCOがされている場合
	// 全人狼陣営が占いCOしている場合
		if ( (WOLF_NUM+POS_NUM) == seerCOList.size() ){
			ArrayList<Role>    roleList     = new ArrayList<Role>();
			for ( int i = 0; i < (WOLF_NUM+POS_NUM); i++ ){
				for ( int j = 0; j < (WOLF_NUM+POS_NUM); j++ ){
					if ( i == j ){
						roleList.add(Role.POSSESSED);
					}else{
						roleList.add(Role.WEREWOLF);
					}
				}
				ArrayList<Integer> list = tableIndexList(seerCOList, roleList);
				double             rate = getRates()[9];
				for ( int idx : list ){
					getRateTable()[idx][1] *= rate;
				}
			}
	// 全人狼陣営が占いCOしているわけではない場合
		}else if ( (WOLF_NUM+POS_NUM) > seerCOList.size() ){
		// 狂人を含まないパターン
			ArrayList<Role> roleList = new ArrayList<Role>();
			for ( int i = 0; i < seerCOList.size(); i++ ){
				roleList.add(Role.WEREWOLF);
			}
			ArrayList<Integer> list = tableIndexList(seerCOList, roleList);
			double             rate = getRates()[9];
			for ( int idx : list ){
				getRateTable()[idx][1] *= rate;
			}
		// 狂人を含むパターン
			for ( int i = 0; i < seerCOList.size(); i++ ){
				roleList = new ArrayList<Role>();
				for ( int j = 0; j < seerCOList.size(); j++ ){
					if ( i == j ){
						roleList.add(Role.POSSESSED);
					}else{
						roleList.add(Role.WEREWOLF);
					}
				}
				list = new ArrayList<Integer>();
				list = tableIndexList(seerCOList, roleList);
				rate = getRates()[9];
				for ( int idx : list ){
					getRateTable()[idx][1] *= rate;
				}
			}
		}

	// 村人陣営から占いCOが 2以上 の場合
	// 一度の更新で重複して更新される組合せがあるが, 現在は無視
		ArrayList<Integer> agentIdxList = new ArrayList<Integer>();
		ArrayList<Role>    roleList     = new ArrayList<Role>();
		for ( int i = 0; i < seerCOList.size()-1; i++ ){
			agentIdxList.clear();
			roleList.clear();
			for ( int j = i+1; j < seerCOList.size(); j++ ){
				agentIdxList.add(seerCOList.get(i));
				roleList.add(Role.VILLAGER);
				agentIdxList.add(seerCOList.get(j));
				roleList.add(Role.VILLAGER);
				ArrayList<Integer> list = tableIndexList(agentIdxList, roleList);
				double             rate = getRates()[12];
				for ( int idx : list ){
					getRateTable()[idx][1] *= rate;
				}
			}
		}
	}





	@Override
	public void calcMediumCOInfo(ArrayList<Integer> mediumCOList) {
	// 人狼陣営からのみ霊能COがされている場合
	// 全人狼陣営が霊能COしている場合
		if ( (WOLF_NUM+POS_NUM) == mediumCOList.size() ){
			ArrayList<Role>    roleList     = new ArrayList<Role>();
			for ( int i = 0; i < (WOLF_NUM+POS_NUM); i++ ){
				for ( int j = 0; j < (WOLF_NUM+POS_NUM); j++ ){
					if ( i == j ){
						roleList.add(Role.POSSESSED);
					}else{
						roleList.add(Role.WEREWOLF);
					}
				}
				ArrayList<Integer> list = tableIndexList(mediumCOList, roleList);
				double             rate = getRates()[10];
				for ( int idx : list ){
					getRateTable()[idx][1] *= rate;
				}
			}
	// 全人狼陣営が霊能COしているわけではない場合
		}else if ( (WOLF_NUM+POS_NUM) > mediumCOList.size() ){
		// 狂人を含まないパターン
			ArrayList<Role> roleList = new ArrayList<Role>();
			for ( int i = 0; i < mediumCOList.size(); i++ ){
				roleList.add(Role.WEREWOLF);
			}
			ArrayList<Integer> list = tableIndexList(mediumCOList, roleList);
			double             rate = getRates()[10];
			for ( int idx : list ){
				getRateTable()[idx][1] *= rate;
			}
		// 狂人を含むパターン
			for ( int i = 0; i < mediumCOList.size(); i++ ){
				roleList = new ArrayList<Role>();
				for ( int j = 0; j < mediumCOList.size(); j++ ){
					if ( i == j ){
						roleList.add(Role.POSSESSED);
					}else{
						roleList.add(Role.WEREWOLF);
					}
				}
				list = new ArrayList<Integer>();
				list = tableIndexList(mediumCOList, roleList);
				rate = getRates()[10];
				for ( int idx : list ){
					getRateTable()[idx][1] *= rate;
				}
			}
		}

	// 村人陣営から霊能COが 2 の場合
	// 一度の更新で重複して更新される組合せがあるが, 現在は無視
		ArrayList<Integer> agentIdxList = new ArrayList<Integer>();
		ArrayList<Role>    roleList     = new ArrayList<Role>();
		for ( int i = 0; i < mediumCOList.size()-1; i++ ){
			agentIdxList.clear();
			roleList.clear();
			for ( int j = i+1; j < mediumCOList.size(); j++ ){
				agentIdxList.add(mediumCOList.get(i));
				roleList.add(Role.VILLAGER);
				agentIdxList.add(mediumCOList.get(j));
				roleList.add(Role.VILLAGER);
				ArrayList<Integer> list = tableIndexList(agentIdxList, roleList);
				double             rate = getRates()[13];
				for ( int idx : list ){
					getRateTable()[idx][1] *= rate;
				}
			}
		}
	}



	@Override
	public void calcBGCOInfo(ArrayList<Integer> BGCOList) {
	// 村人陣営から狩COが 2 の場合
	// 一度の更新で重複して更新される組合せがあるが, 現在は無視
		ArrayList<Integer> agentIdxList = new ArrayList<Integer>();
		ArrayList<Role>    roleList     = new ArrayList<Role>();
		for ( int i = 0; i < BGCOList.size()-1; i++ ){
			agentIdxList.clear();
			roleList.clear();
			for ( int j = i+1; j < BGCOList.size(); j++ ){
				agentIdxList.add(BGCOList.get(i));
				roleList.add(Role.VILLAGER);
				agentIdxList.add(BGCOList.get(j));
				roleList.add(Role.VILLAGER);
				ArrayList<Integer> list = tableIndexList(agentIdxList, roleList);
				double             rate = getRates()[14];
				for ( int idx : list ){
					getRateTable()[idx][1] *= rate;
				}
			}
		}
	}


/**
 * COしていないことによる人外テーブルの更新
 *
 * @param notCOList COしていないエージェントの番号リスト
 */
	public void calcNotCOInfo(ArrayList<Integer> notCOList){
	// 狂人がCOしない
		for ( int i = 0; i < notCOList.size(); i++) {
			ArrayList<Integer> list = tableIndexList(notCOList.get(i), Role.POSSESSED);
			double             rate = getRates()[11];
			for ( int idx : list ){
				getRateTable()[idx][1] *= rate;
			}
		}
	}


	public void calcPatternInfo(int seerIdx, COData seerCOData, int mediumIdx, COData mediumCOData){
		// 実装無
	}


//	public void self(int start, int length){
//		if ( start == length ){
//			int[] t_ = new int[length];
//			for ( int i = 0; i < length; i++ ){
//				t_[i] = temp_[i];
//			}
//			patterns_.add(t_);
//		}else{
//			self(start+1, length);
//			temp_[start] = 1;
//			self(start+1, length);
//			temp_[start] = 0;
//		}
//	}







	public static void main(String[] args) {
		// TODO 自動生成されたメソッド・スタブ

	}

}
