package com.gmail.sg06.greenrevolution.player;

import java.util.ArrayList;
import java.util.LinkedHashMap;

import org.aiwolf.client.lib.TemplateWhisperFactory;
import org.aiwolf.common.data.Agent;
import org.aiwolf.common.net.GameInfo;
import org.aiwolf.common.net.GameSetting;

import com.gmail.sg06.greenrevolution.data.COData;

public class AttackMediumWerewolf extends JuN1roWerewolf {

	ArrayList<Integer> wolfIdx = new ArrayList<Integer>();
	ArrayList<Integer> possessedIdx = new ArrayList<Integer>();

	@Override
	public void initialize(GameInfo gameInfo, GameSetting gameSetting) {
		super.initialize(gameInfo, gameSetting);
	}

	@Override
	public void dayStart() {
		super.dayStart();
	}

	@Override
	public String talk() {
		return super.talk();
	}

	@Override
	public Agent vote() {

		wolfIdx = getWolfIdx();
		possessedIdx = getPossessedIdx();
		// 狂人を見つけた時、そいつの黒出しに便乗
		ArrayList<Integer> posblack = new ArrayList<Integer>();
		ArrayList<Integer> aliveblack = new ArrayList<Integer>();
		if (possessedIdx != null) {
			if (possessedIdx.size() > 0) {
				LinkedHashMap<Integer, COData> seer_map = getData()
						.getSeerCODataMap();
				COData posData = seer_map.get(possessedIdx.get(0));
				posblack = posData.getBlackList();
			// 最初から生存者を全部入れる必要はない？
//				aliveblack = getData().getAliveAgentList();
				if (posblack.size() > 0) {
					for (int idx : posblack) {
						if (getData().isAlive(idx) && !wolfIdx.contains(idx)) {
							aliveblack.add(idx);
						}
					}
				}
			}
		}
	// 多分ここはサイズで判断しないと危ない.
//		if (aliveblack != null) {
		if ( aliveblack.size() > 0 ){
			int target = getData().getMaxLikelyExecuteAgent(aliveblack);
			if (target > 0) {
				return getLatestDayGameInfo().getAgentList().get(target - 1);
			}
		}

		// 他狼の黒出しに便乗
		ArrayList<Integer> wolfblack = new ArrayList<Integer>();
		for (int widx : wolfIdx) {
			LinkedHashMap<Integer, COData> seer_map = getData()
					.getSeerCODataMap();
			if (seer_map.containsKey(widx)) {
				COData wolfData = seer_map.get(widx);
				wolfblack = wolfData.getBlackList();
			// 最初から生存者を全部入れる必要はない？
//				aliveblack = getData().getAliveAgentList();
				if (wolfblack.size() > 0) {
					for (int aidx : wolfblack) {
						if (getData().isAlive(aidx)) {
							aliveblack.add(aidx);
						}
					}
				}
			}
		}
	// 多分ここはサイズで判断しないと危ない.
//		if (aliveblack != null) {
		if ( aliveblack.size() > 0 ){
//			System.out.println(aliveblack.size());
			int target = getData().getMaxLikelyExecuteAgent(aliveblack);
			return getLatestDayGameInfo().getAgentList().get(target - 1);
		}

		return super.vote();
	}

	@Override
	public Agent attack() {
	// 霊能 CO した狼を噛もうとするのは避ける(念のため)
		if ( (willattack_!=null) && !getWolfIdx().contains(willattack_.getAgentIdx()) ){
			return willattack_;
		}
		return super.attack();
	}

	@Override
	public String whisper() {

		// 真霊優先噛み
		medium_ = getData().getTodayMediumCOAgentList();

		if (medium_.size() == 1) {
			willattack_ = getMaxLikelyVillAgent(medium_);
		// 霊能 CO した狼は避ける(念のため)
			if ( (willattack_!=null) && !getWolfIdx().contains(willattack_.getAgentIdx()) ){
				return TemplateWhisperFactory.attack(willattack_);
			}
		}

		return super.whisper();
	}

}
