package com.gmail.sg06.greenrevolution.player;

import org.aiwolf.client.lib.TemplateTalkFactory;
import org.aiwolf.common.data.Agent;
import org.aiwolf.common.data.Role;
import org.aiwolf.common.data.Species;
import org.aiwolf.common.net.GameInfo;
import org.aiwolf.common.net.GameSetting;

public class BasePossessed extends BaseRole {

	private boolean isCO_;

	private boolean isResult_;

	@Override
	public void initialize(GameInfo gameInfo, GameSetting gameSetting) {
		super.initialize(gameInfo, gameSetting);
		setCO(false);
	}

	@Override
	public void dayStart() {
		super.dayStart();
		setResult(false);
	}

	@Override
	public String talk() {
		if(!isCO()){
			setCO(true);
			return TemplateTalkFactory.comingout(getMe(), Role.SEER);
		}
		if(!isResult() && getDay() != 0){
			setResult(true);
			Agent target = liedivine();
			return TemplateTalkFactory.divined(target, Species.HUMAN);
		}
		return super.talk();
	}

	@Override
	public Agent vote() {
		return super.vote();
	}

	/*
	 * 嘘の占い対象を返す(現在は最黒)
	 * 自分や占い済みを除いたリストでのgetMaxLikelyWolfAgentが使えると幸せ
	 */
	public Agent liedivine(){
		Agent target = getMaxLikelyWolfAgent();
		if(target != null){
			return target;
		}
		return null;
	}

	public boolean isResult() {
		return isResult_;
	}

	public void setResult(boolean isResult) {
		isResult_ = isResult;
	}

	public boolean isCO() {
		return isCO_;
	}

	public void setCO(boolean isCO) {
		isCO_ = isCO;
	}
}
