package com.gmail.sg06.greenrevolution.player;

import org.aiwolf.client.lib.TemplateTalkFactory;
import org.aiwolf.common.data.Agent;
import org.aiwolf.common.data.Role;
import org.aiwolf.common.net.GameInfo;
import org.aiwolf.common.net.GameSetting;

public class BodyguardCOWerewolf extends JuN1roWerewolf{

	private Integer turn = 0;
	private boolean isBGCO;

	@Override
	public void initialize(GameInfo gameInfo, GameSetting gameSetting) {
		super.initialize(gameInfo, gameSetting);
		isBGCO = false;
	}

	@Override
	public void dayStart() {
		super.dayStart();
		turn = 0;
	}

	@Override
	public String talk() {
		getData().update(getLatestDayGameInfo());
		getData().tableUpdate(1);
		turn++;

		//6ターン目以降、吊られそうであれば狩人CO
		if(turn > 5 && !isBGCO){
			Integer executeIdx = getData().getMaxLikelyExecuteAgent();
			Integer me = getMe().getAgentIdx();
			if( executeIdx == me){
				isBGCO = true;
				return TemplateTalkFactory.comingout(getMe(),Role.BODYGUARD);
			}
		}

		return super.talk();
	}

	@Override
	public Agent vote() {
		return super.vote();
	}

	@Override
	public Agent attack() {
		return super.attack();
	}

	@Override
	public String whisper() {
		return super.whisper();
	}

}
