package com.gmail.sg06.greenrevolution.player;

import java.util.ArrayList;

import org.aiwolf.client.lib.TemplateTalkFactory;
import org.aiwolf.common.data.Agent;
import org.aiwolf.common.data.Role;
import org.aiwolf.common.data.Species;
import org.aiwolf.common.net.GameInfo;
import org.aiwolf.common.net.GameSetting;

public class RivalBlackPossessed extends JuN1roPossessed2{

	private ArrayList<Integer> divineList_ = new ArrayList<Integer>();
	private Agent willvote_ ;

	//BJP
		@Override
		public void initialize(GameInfo gameInfo, GameSetting gameSetting) {
			super.initialize(gameInfo, gameSetting);
		}


		@Override
		public void dayStart() {
			super.dayStart();
			willvote_ = null;
		}


		@Override
		public String talk() {
			getData().update(getLatestDayGameInfo());
			if  (getData().isOneTimeCall() ){
				getData().tableUpdate(1);
			}

			ArrayList<Integer> seerList = new ArrayList<Integer>();
			ArrayList<Integer> mediumList = new ArrayList<Integer>();
			seerList = getData().getTodaySeerCOAgentList();
			seerList.remove(getMe());
			mediumList = getData().getTodayMediumCOAgentList();

			if(!isCO()){
				setCO(true);
				return TemplateTalkFactory.comingout(getMe(), Role.SEER);
			}
			if(!isResult() && getDay() != 0){
				setResult(true);
				Agent target;

				if(seerList.size() == 1){
					target =  getLatestDayGameInfo().getAgentList().get(seerList.get(0) - 1);
					divineList_.add(seerList.get(0));
					return TemplateTalkFactory.divined(target, Species.WEREWOLF);
				}
				else if(mediumList.size() == 1){
					target =  getLatestDayGameInfo().getAgentList().get(mediumList.get(0) - 1);
					divineList_.add(mediumList.get(0));
					return TemplateTalkFactory.divined(target, Species.WEREWOLF);
				}else{
					target = getMaxLikelyVillAgent();
					divineList_.add(target.getAgentIdx());
					return TemplateTalkFactory.divined(target, Species.HUMAN);
				}
			}

			return TemplateTalkFactory.skip();
		}

		@Override
		public Agent vote() {
			getData().tableUpdate(1);

			ArrayList<Integer> candidate = new ArrayList<Integer>();
			candidate = getData().getAliveAgentList();
			candidate.remove(getMe());
			Integer maybeExecute = getData().getMaxLikelyExecuteAgent();

			//生存者の中で吊られそうなやつ(自分以外)に便乗投票
			if( maybeExecute != null && maybeExecute != getMe().getAgentIdx()){
				willvote_ = getLatestDayGameInfo().getAgentList().get(maybeExecute - 1);
			}

			if(willvote_ != null){
				return willvote_;
			}else{
				return super.vote();
			}
		}


}
