package com.gmail.sg06.greenrevolution.player;

import java.util.ArrayList;
import java.util.Random;

import org.aiwolf.client.lib.TemplateTalkFactory;
import org.aiwolf.common.data.Agent;
import org.aiwolf.common.data.Role;
import org.aiwolf.common.data.Species;
import org.aiwolf.common.net.GameInfo;
import org.aiwolf.common.net.GameSetting;

public class RoleCOWerewolf extends JuN1roWerewolf{

	ArrayList<Integer> wolfIdx = new ArrayList<Integer>();
	ArrayList<Integer> myDivinedList_ = new ArrayList<Integer>();
	ArrayList<Integer> DivineCandidateList_ = new ArrayList<Integer>();
	ArrayList<Integer> myBlackList_ = new ArrayList<Integer>();
	Role fakerole_ = Role.VILLAGER;
	boolean isCO, isResult;
	Random rnd = new Random();
	Integer blackTimes;


	@Override
	public void initialize(GameInfo gameInfo, GameSetting gameSetting) {
		super.initialize(gameInfo, gameSetting);
		isCO = false;
		isResult = false;
		blackTimes = 0;
	}
	@Override
	public void dayStart() {
		super.dayStart();
		isResult = false;
	}

	@Override
	public String talk() {

		//0日目CO
		if(getDay() == 0 && !isCO){
			RoleCO();
			if(isCO){	return TemplateTalkFactory.comingout(getMe(), fakerole_); }
			isCO = true;
		}

		//CO別のtalk

		//占い師
		if(getDay() > 0 && fakerole_ == Role.SEER  && !isResult){
			DivineCandidateList_ = (ArrayList<Integer>) getData().getAliveAgentList().clone();
			DivineCandidateList_.removeAll(myDivinedList_);
			Agent divined = getMaxLikelyWolfAgent(DivineCandidateList_);
			myDivinedList_.add(divined.getAgentIdx());
			wolfIdx = getWolfIdx();
			isResult = true;
			if(!wolfIdx.contains(divined.getAgentIdx()) && blackTimes < 3 && rnd.nextInt(2) == 1){
				blackTimes++;
				myBlackList_.add(divined.getAgentIdx());
				return TemplateTalkFactory.divined(divined, Species.WEREWOLF);
			}else{
				return TemplateTalkFactory.divined(divined, Species.HUMAN);
			}
		}

		//霊媒師
		if(getDay() > 1 && fakerole_ == Role.MEDIUM  && !isResult){
			Agent divined = getLatestDayGameInfo().getExecutedAgent();
			isResult = true;
			if( wolfIdx.contains(divined.getAgentIdx()) && rnd.nextInt(2) == 1){
				return TemplateTalkFactory.divined(divined, Species.WEREWOLF);
			}else{
				return TemplateTalkFactory.divined(divined, Species.HUMAN);
			}
		}

		return super.talk();
	}

	@Override
	public Agent vote() {
		if(myBlackList_ != null){
			Integer targetIdx = getData().getMaxLikelyExecuteAgent(myBlackList_);
			if(targetIdx != null && targetIdx != -1){
				return getLatestDayGameInfo().getAgentList().get(targetIdx - 1);
			}
		}
		return super.vote();
	}

	@Override
	public Agent attack() {


		return super.attack();
	}

	@Override
	public String whisper() {
		//占狩霊優先噛み(狂人考慮)
		seer_		= getData().getTodaySeerCOAgentList();
		medium_		= getData().getTodayMediumCOAgentList();
		bodyguard_	= getData().getTodayBGCOAgentList();
		String willtalk = null;

		getData().update(getGameInfo(getDay()));
		if (!getData().isCall()) {
			getData().tableUpdate(1);

			//狂人探し
			judge();

			//偶数日占、奇数日霊、不在でランダム噛み
			if(getDay() %2 == 0){
				willtalk = RoleAttack(seer_);
				if( willtalk == null )	{ willattack_ = getMaxLikelyVillAgent(); }
			}else{
				willtalk = RoleAttack(medium_);
				if( willtalk == null )	{ willattack_ = getMaxLikelyVillAgent(); }
			}

			if( willtalk != null ){ return willtalk; }
		}
		return super.whisper();
	}


	/**
	 * 占or霊CO
	 */
	public void RoleCO() {
		Integer r = rnd.nextInt(10);
		//0.5の確率で占いCO
		if( r < 5 ){
			isCO = true;
			fakerole_ = Role.SEER;
		}
		if( r < 6 ){
			isCO = true;
			fakerole_ = Role.MEDIUM;
		}
	}

}
