package com.gmail.sg06.greenrevolution.player;

import java.util.ArrayList;
import java.util.HashMap;

import org.aiwolf.common.data.Agent;
import org.aiwolf.common.net.GameInfo;
import org.aiwolf.common.net.GameSetting;

public class SameVotePossessed extends JuN1roPossessed3 {

	// 絶対霊媒CO
	// talkは狼に便乗

	private Agent willvote_;

	@Override
	public void initialize(GameInfo gameInfo, GameSetting gameSetting) {
		super.initialize(gameInfo, gameSetting);
	}

	@Override
	public void dayStart() {
		super.dayStart();
		willvote_ = null;
	}

	@Override
	public String talk() {
		return super.talk();
	}

	@Override
	public Agent vote() {
		getData().tableUpdate(1);

		ArrayList<Integer> candidate = getData().getAliveAgentList();
		Integer maybeExecute = getData().getMaxLikelyExecuteAgent();
		HashMap<Integer, Integer> voteMap = getData().getVoteMap();

		// 生存者の中で一番狼っぽいやつのvote宣言に便乗
		Agent maybeWolf = getMaxLikelyWolfAgent();
		Integer hisvote = voteMap.get(maybeWolf.getAgentIdx());
		if (hisvote != -1 && maybeExecute != maybeWolf.getAgentIdx()) {
			willvote_ = getLatestDayGameInfo().getAgentList().get(hisvote - 1);
		}

		// 生存者の中で二番目に狼っぽいやつのvote宣言に便乗
		if (willvote_ == null) {
			if (candidate.contains(Integer.valueOf(maybeWolf.getAgentIdx()))) {
				candidate.remove(Integer.valueOf(maybeWolf.getAgentIdx()));
			}
			maybeWolf = getMaxLikelyWolfAgent(candidate);
			hisvote = voteMap.get(maybeWolf.getAgentIdx());
			if (hisvote != -1 && maybeExecute != maybeWolf.getAgentIdx()) {
				willvote_ = getLatestDayGameInfo().getAgentList().get(
						hisvote - 1);
			}
		}

		if (willvote_ != null) {
			return willvote_;
		} else {
			return super.vote();
		}
	}
}
